/**
 * Sample number: 18 (of 20)
 * Result number: 197
 * Function name: int im_get_status(void)
 * File: src/mbyte.c
 * Start: 5253
 */
    int
im_get_status(void)
{
#  ifdef FEAT_EVAL
    if (p_imsf[0] != NUL)
    {
	int is_active;

	/* FIXME: Don't execute user function in unsafe situation. */
	if (exiting
#   ifdef FEAT_AUTOCMD
		|| is_autocmd_blocked()
#   endif
		)
	    return FALSE;
	/* FIXME: :py print 'xxx' is shown duplicate result.
	 * Use silent to avoid it. */
	++msg_silent;
	is_active = call_func_retnr(p_imsf, 0, NULL, FALSE);
	--msg_silent;
	return (is_active > 0);
    }
#  endif
    return im_is_active;
}

/** End sample number: 18 */

